import { defineRouter } from "#q-app/wrappers";
import {
  createRouter,
  createMemoryHistory,
  createWebHistory,
  createWebHashHistory,
} from "vue-router";
import routes from "./routes";
import { Notify } from "quasar";
import { permissionStore } from "src/stores/permission";
import { i18n } from "src/boot/i18n";
import { userStore } from "src/stores/user";
import { useAuth } from "src/composables/useAuth";
/*
 * If not building with SSR mode, you can
 * directly export the Router instantiation;
 *
 * The function below can be async too; either use
 * async/await or return a Promise which resolves
 * with the Router instance.
 */

export default defineRouter(function (/* { store, ssrContext } */) {
  const createHistory = process.env.SERVER
    ? createMemoryHistory
    : process.env.VUE_ROUTER_MODE === "history"
      ? createWebHistory
      : createWebHashHistory;

  const Router = createRouter({
    scrollBehavior: () => ({ left: 0, top: 0 }),
    routes,

    // Leave this as is and make changes in quasar.conf.js instead!
    // quasar.conf.js -> build -> vueRouterMode
    // quasar.conf.js -> build -> publicPath
    history: createHistory(process.env.VUE_ROUTER_BASE),
  });
  let refreshed = false;
  Router.beforeEach(async (to, from, next) => {
    if (userStore().accessToken == null && !refreshed) {
      try {
        await useAuth().refresh();
      } catch {
        refreshed = true;
        if (!to.meta.public) {
          return next({ name: "LoginPage" });
        }
      }
    }
    if (userStore().accessToken) {
      if (to.name == "LoginPage") {
        return next({ name: "DashboardPage" });
      }
    }
    if (to.meta.requiredPermission) {
      const { getAccess } = permissionStore();
      const permission = getAccess(to.meta.requiredPermission, "view");
      if (!permission) {
        Notify.create({
          message: i18n.global.t("validation.permissions.view"),
          type: "negative",
        });
        return next(from);
      }
    }
    return next();
  });

  return Router;
});
